require ("de-GUI")
local entity_list = {'roboport', 'construction-robot', 'logistic-robot'}

script.on_init(function ()
  if not global then global = {} end
  if not global.entities then global.entities = {} end
  if not global.states then global.states = {} end

  for player_index, player in pairs (game.players) do
    add_gui(player_index, entity_list)
    for i, entity_name in pairs (entity_list) do
      find_entities (event, entity_name)
    end
  end

end)

function is_value_in_list (value, list) 
  for i, v in pairs (list) do
    if v == value then
      return true
    end
  end
  return false
end

script.on_event(defines.events.on_gui_click, function (event)
  local button_name = event.element.name
    if (string.sub(button_name, 1, 3) == "de_") then
      local entity_name = string.sub(button_name, 4)
      if is_value_in_list (entity_name, entity_list) then
        on_gui_click (event, entity_name)
      else
        printAll("Exception: " .. button_name .. " was not defined")
      end
    end
end)


function find_entities (event, entity_name)
  local surface = game.surfaces[1]
  local entities = surface.find_entities_filtered{name=entity_name}
  global.entities[entity_name] = entities -- must be added, not rewritten
  global.states[entity_name] = false
end


function on_gui_click (event, entity_name)
  local player = game.players[event.player_index]
  -- printAll("Was clicked entity_name: " .. entity_name)
  change_button_color(player, entity_name)
  change_state_of_entity (entity_name)
end

function change_state_of_entity (entity_name)
  local bool = global.states[entity_name]
  if not (bool) then 
    -- printAll("find_entities " .. entity_name)
    find_entities (event, entity_name)
  end
  local tabl = global.entities[entity_name]
  for i, entity in pairs (tabl) do
    if entity.valid then
      entity.active = bool
      else
      printAll("entity " .. entity_name .. " #" .. i .. " was not valid! Total amount: " .. #tabl)
    end
  end
  if bool then
    printAll("Disable Entities: All entities '" .. entity_name .. "' are enabled")
  else
    printAll("Disable Entities: All entities '" .. entity_name .. "' are disabled")
  end
  global.states[entity_name] = not bool
end

function printAll(text)
  if type (text) == "table" then
    text = serpent.block(text, {comment = false})
  end
	log (text)
	for player_index, player in pairs (game.players) do
		game.players[player_index].print (text)
	end
end